urls.py
#
# Copyright (C) 2016-2022 Mattia Basaglia
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
from django.conf.urls import url

from . import views


formats = "|".join(fmt.name for fmt in views.output_formats)

app_name="insult"
urlpatterns = [
    url(r'^$', views.help, name="help"),
    url(
        r'^insult\.(?P<format>%s)' % formats,
        views.FormatDispatcher.as_view(),
        name="api"
    ),
    url(
        r'^(?P<lang>[a-zA-Z_]+)/insult\.(?P<format>%s)' % formats,
        views.FormatDispatcher.as_view(),
        name="api_lang"
    ),
    url(
        r'^insult',
        views.TextFormat.as_view(),
        name="api_txt"
    ),
    url(
        r'^adjective\.(?P<format>%s)' % formats,
        views.FormatDispatcher.as_view(
            default_template="<adjective>",
            allow_override_template=False,
        ),
        name="api_adjective"
    ),
    url(
        r'^(?P<lang>[a-zA-Z_]+)/adjective\.(?P<format>%s)' % formats,
        views.FormatDispatcher.as_view(
            default_template="<adjective>",
            allow_override_template=False,
        ),
        name="api_adjective_lang"
    ),
    url(
        r'^adjective',
        views.TextFormat.as_view(
            default_template="<adjective>",
            allow_override_template=False,
        ),
        name="api_adjective_txt"
    ),
    url(r'^explore$', views.explore, name="explore"),
]

templates/django_insult/api_explore.html
<!DOCTYPE html>
<html>
<head>
    <title>Explore API</title>
    <style>
option.default {
    font-style: oblique;
}

option:not(.default) {
    font-family: monospace;
}

.api_url
{
    font-family: monospace;
    font-size: larger;
}
a.api_url:active, a.api_url:visited, a.api_url:link {
    color: black;
    text-decoration: none;
    border-bottom: 1px dotted black;
}
a.api_url:hover {
    color: black;
    border-bottom: 1px solid black;
}

#preview_url {
    border: 1px solid gray;
    border-radius: 8px 8px 0 0;
    display: inline-block;
    font-family: monospace;
    margin: 2ex 2ex 0;
    padding: 1em;
    white-space: pre-wrap;
    border-bottom: 0;
}

#preview_response {
    border: 1px solid gray;
    font-family: monospace;
    margin: 0 2ex 2ex;
    padding: 1em;
    white-space: pre-wrap;
}
    </style>
</head>
<body>
<form method="post">
<table>
<h1>Explore API</h1>
<p>View the <a href="{% url 'insult:help' %}">API Help</a>.</p>
<tbody>
    <tr>
        <th><label for="lang">Language</label></th>
        <td>
            <select name="lang" id="lang">
                <option value="" class="default">Default</option>
                {% for lang in languages %}
                    <option value="{{ lang }}">{{ lang }}</option>
                {% endfor %}
            </select>
        </td>
    </tr>
    <tr>
        <th><label for="format">Format</label></th>
        <td>
            <select name="format" id="format">
                {% for format in formats %}
                    <option value="{{ format.name }}">{{ format.name }}</option>
                {% endfor %}
            </select>
        </td>
    </tr>
    <tr>
        <th><label for="template">Template</label></th>
        <td>
            <textarea id="template" name="template" rows="10" cols="40"></textarea>
        </td>
    </tr>
    <tr>
        <th><label for="who">Who</label></th>
        <td>
            <input type="text" id="who" name="who" />
        </td>
    </tr>
    <tr>
        <th><label for="plural">Plural</label></th>
        <td>
            <input type="checkbox" id="plural" name="plural" />
        </td>
    </tr>
</tbody>
</table>
<input type="submit" value="View" />

<script>

var preview = null;
var preview_url = null;
var preview_response = null;

function create_preview_div()
{
    if ( preview )
        return;

    preview = document.createElement("div");

    var preview_title = document.createElement("h2")
    preview_title.appendChild(document.createTextNode("Preview"));
    preview.appendChild(preview_title);

    preview_url = document.createElement("div");
    preview_url.id = "preview_url";
    preview.appendChild(preview_url);

    preview_response = document.createElement("div");
    preview_response.id = "preview_response";
    preview.appendChild(preview_response);

    document.body.appendChild(preview);
}


function form_submit(ev)
{
    var request = new XMLHttpRequest();
    request.onload = function()
    {
        create_preview_div();
        var url = request.getResponseHeader("X-Insult-Url");
        var link = document.createElement("a");
        link.className = "api_url";
        link.appendChild(document.createTextNode(url));
        link.setAttribute("href", url);
        if (preview_url.firstChild)
        {
            preview_url.removeChild(preview_url.firstChild);
        }
        preview_url.appendChild(link);

        if (request.status == 200)
        {
            preview_response.innerText = request.responseText;
        }
    };

    request.open("POST", "", true);
    var form_data = new FormData(document.getElementsByTagName("form")[0]);
    request.send(form_data);

    ev.preventDefault();
}

var form = document.forms[0];
form.addEventListener('submit', form_submit, false);
</script>
</form>
</body>

templates/django_insult/api_help.html
{% load misc %}
<!DOCTYPE html>
<html>
<head>
    <title>Insult API</title>
    <style>
td, th
{
    border: 1px solid gray;
    padding: 0.25em;
}
table
{
    border-collapse: collapse;
}
th
{
    background-color: #edc;
}
table.api_params > tbody > tr td:first-child
{
    font-family: monospace;
    font-weight: bold;
}
table .fixed_string, .http_status
{
    font-family: monospace;
}
span.none
{
    font-style: oblique;
    color: #555;
}

.api_url
{
    font-family: monospace;
    font-size: larger;
}
a.api_url:active, a.api_url:visited, a.api_url:link {
    color: black;
    text-decoration: none;
    border-bottom: 1px dotted black;
}
a.api_url:hover {
    color: black;
    border-bottom: 1px solid black;
}

.section a:active, .section a:visited, .section a:link, .section a:hover {
    color: black;
    text-decoration: none;
}

.section a:hover:after {
    content: "¶";
}


.api_url_section {
    border-top: 1px solid gray;
    padding-top: 1ex;
}
    </style>
</head>
<body>
{% section h1 %}Insult API{% endsection %}

{% section h2 %}Formats{% endsection %}

<table>
    <thead><tr><th>Format</th><th>Content Type</th></tr></thead>
    <tbody>
        {% for format in formats %}
            <tr><td class="fixed_string">{{ format.name }}</td><td>{{ format.content_type }}</td></tr>
        {% endfor %}
    </tbody>
</table>

{% section h2 %}Explore{% endsection %}

<p>You can play with the various parameters with the <a href="{% url 'insult:explore' %}">API Explorer</a>.</p>

{% section h2 %}Responses{% endsection %}

<p>In case of a successful request, the API will return a
<span class="http_status">200</span> page with the insult formatted in the
requested format.</p>

<p>In case of incorrect parameters, the API will return a
<span class="http_status">400</span> error, the body of the response depends on
the format.</p>

{% section h3 %}JSON{% endsection %}

<p>A successful responses will contain the following data:</p>

<table>
    <thead><tr><th>Name</th><th>Value</th></tr></thead>
    <tbody>
        <tr><td class="parameter">error</td><td><span class="fixed_string">false</span></td></tr>
        <tr><td class="parameter">insult</td><td>The generated string</td></tr>
        <tr><td class="parameter">args</td><td>A dictionary listing the parameters used to generate the output, including default values.</td></tr>
    </tbody>
</table>

<p>A failed response will have the following:</p>

<table>
    <thead><tr><th>Name</th><th>Value</th></tr></thead>
    <tbody>
        <tr><td class="parameter">error</td><td><span class="fixed_string">true</span></td></tr>
        <tr><td class="parameter">error_message</td><td>A brief message describing the reason for the error.</td></tr>
    </tbody>
</table>

{% section h2 %}Methods{% endsection %}
{% section h3 %}GET{% endsection %}

{% section h4 class='section api_url_section' %}/insult{% endsection %}
{% api_url_link 'insult:api_txt' %}
<p>Generates an insult in plain text.</p>
<table class="api_params">
    <thead><tr><th>Name</th><th>Description</th><th>Default</th></tr></thead>
    <tbody>
        <tr><td class="parameter">lang</td><td>Language</td><td class="fixed_string">{{ default_language }}</td></tr>
        <tr><td class="parameter">template</td><td>Insult template</td><td class="fixed_string">{{ default_template }}</td></tr>
        <tr><td class="parameter">who</td><td>Person to insult, changes the template to third person singular.</td><td class="fixed_string"><span class="none">None</span></td></tr>
        <tr><td class="parameter">plural</td><td>If present (with <span class="fixed_string">who</span>) changes the template to third person plural.</td><td class="fixed_string"><span class="none">None</span></td></tr>
    </tbody>
    <caption>Parameters</caption>
</table>

{% section h4 class='section api_url_section' %}/insult.<em>format</em>{% endsection %}
{% api_url_link 'insult:api' format='html' %}
<p>Generates an insult in one of the supported formats.</p>
<table class="api_params">
    <thead><tr><th>Name</th><th>Description</th><th>Default</th></tr></thead>
    <tbody>
        <tr><td class="parameter">lang</td><td>Language</td><td class="fixed_string">{{ default_language }}</td></tr>
        <tr><td class="parameter">template</td><td>Insult template</td><td class="fixed_string">{{ default_template }}</td></tr>
        <tr><td class="parameter">who</td><td>Person to insult, changes the template to third person singular.</td><td class="fixed_string"><span class="none">None</span></td></tr>
        <tr><td class="parameter">plural</td><td>If present (with <span class="fixed_string">who</span>) changes the template to third person plural.</td><td class="fixed_string"><span class="none">None</span></td></tr>
    </tbody>
    <caption>Parameters</caption>
</table>

{% section h4 class='section api_url_section' %}/<em>lang</em>/insult.<em>format</em>{% endsection %}
{% api_url_link 'insult:api_lang' format='html' lang='en' %}
<p>Generates an insult in a fixed language.</p>
<table class="api_params">
    <thead><tr><th>Name</th><th>Description</th><th>Default</th></tr></thead>
    <tbody>
        <tr><td class="parameter">template</td><td>Insult template</td><td class="fixed_string">{{ default_template }}</td></tr>
        <tr><td class="parameter">who</td><td>Person to insult, changes the template to third person singular.</td><td class="fixed_string"><span class="none">None</span></td></tr>
        <tr><td class="parameter">plural</td><td>If present (with <span class="fixed_string">who</span>) changes the template to third person plural.</td><td class="fixed_string"><span class="none">None</span></td></tr>
    </tbody>
    <caption>Parameters</caption>
</table>

{% section h4 class='section api_url_section' %}/adjective{% endsection %}
{% api_url_link 'insult:api_adjective_txt' %}
<p>Generates a single adjective in plain text.</p>
<table class="api_params">
    <thead><tr><th>Name</th><th>Description</th><th>Default</th></tr></thead>
    <tbody>
        <tr><td class="parameter">lang</td><td>Language</td><td class="fixed_string">{{ default_language }}</td></tr>
    </tbody>
    <caption>Parameters</caption>
</table>

{% section h4 class='section api_url_section' %}/adjective.<em>format</em>{% endsection %}
{% api_url_link 'insult:api_adjective' format='html' %}
<p>Generates a single adjective in one of the supported formats.</p>
<table class="api_params">
    <thead><tr><th>Name</th><th>Description</th><th>Default</th></tr></thead>
    <tbody>
        <tr><td class="parameter">lang</td><td>Language</td><td class="fixed_string">{{ default_language }}</td></tr>
    </tbody>
    <caption>Parameters</caption>
</table>

{% section h4 class='section api_url_section' %}/<em>lang</em>/adjective.<em>format</em>{% endsection %}
{% api_url_link 'insult:api_adjective_lang' format='html' lang='en' %}
<p>Generates a single adjective in a fixed language.</p>

</body>
</html>

templates/django_insult/error.html
{% load insult %}
<!DOCTYPE html>
<html>
<head>
    <title>Error {{ error_code }}</title>
</head>
<body>
<h1>Error {{ error_code }}: {{ message }}</h1>
<div>{% insult "You <adjective> <animal> <animal_part>!" %}</div>
</body>
</html>

templates/django_insult/format.html
<!DOCTYPE html>
<html>
<head>
    <title>Insult</title>
    <style>
        html {height: 100%; width: 100%; margin: 0; padding: 0;}
        body {display: flex; height: 100%; margin: 0 10%; padding: 0; text-align: center; align-content: center; justify-content: center;}
        h1.insult {font-family: sans-serif; font-size: 12vh; margin: auto; line-height: 100%;}
    </style>
</head>
<body>
<h1 class="insult">{{ insult }}</h1>
</body>
</html>